# -*- coding: utf-8 -*-
"""
Created on Wed Dec 15 14:11:05 2021

@author: Fuad
"""

# -*- coding: utf-8 -*-
"""
Created on Mon Dec 13 20:59:39 2021

@author: Fuad
"""
import numba
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfTransformer

from numba import jit, cuda, njit
from sklearn.feature_extraction.text import TfidfVectorizer
from sklearn import metrics
from numpy import array
from keras.preprocessing.text import one_hot
from keras.preprocessing.sequence import pad_sequences
from keras.models import Sequential
from keras.layers.core import Activation, Dropout, Dense
from keras.layers import Flatten, LSTM
from keras.layers import GlobalMaxPooling1D
from keras.models import Model
from keras.layers.embeddings import Embedding
from sklearn.model_selection import train_test_split
from keras.preprocessing.text import Tokenizer
from keras.layers import Input
from keras.layers.merge import Concatenate
#import imblearn
from sklearn.linear_model import LogisticRegression

import pandas as pd
import numpy as np
import re

import matplotlib.pyplot as plt
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfTransformer
from sklearn.naive_bayes import MultinomialNB
from sklearn.pipeline import Pipeline
from imblearn.over_sampling import SMOTE

from sklearn.linear_model import LogisticRegression
from sklearn.ensemble import RandomForestClassifier
from sklearn.svm import LinearSVC
from sklearn import svm
import creme
import matplotlib.pyplot as plt
from wordcloud import WordCloud, STOPWORDS 
import xgboost
from xgboost import XGBRegressor
import sys

import pandas
import matplotlib.pyplot as plt
from sklearn import model_selection
from sklearn.linear_model import LogisticRegression
from sklearn.tree import DecisionTreeClassifier
from sklearn.neighbors import KNeighborsClassifier
from sklearn.discriminant_analysis import LinearDiscriminantAnalysis
from sklearn.ensemble import RandomForestClassifier
from sklearn.naive_bayes import GaussianNB
from sklearn.svm import SVC
from xgboost import XGBClassifier
from sklearn.neural_network import MLPClassifier
from sklearn.model_selection import cross_val_score
from sklearn.metrics import classification_report
from sklearn.metrics import confusion_matrix
from sklearn.model_selection import cross_val_predict
from nltk.tokenize import  word_tokenize 
#from pyds import MassFunction, powerset
from scipy.sparse import csr_matrix

#@cuda.jit #(nopython=True)

#@jit
#def train_new(models,  X_train, y_train, X_test, y_test):
    #results = []
    #cm = []
    #names = []
    #scoring = 'accuracy'
    #https://scikit-learn.org/stable/modules/cross_validation.html
    #X_train, X_test, y_train, y_test = train_test_split(X, Y, test_size=0.99,  random_state = 0)
    #for model in models:
        #kfold = model_selection.KFold(n_splits=10, shuffle=True, random_state=seed)
        #cv_results = model_selection.cross_val_score(model[1], X_train, y_train, cv=kfold, scoring=scoring)
        #results.append(cv_results)
        #names.append(model[0])
        #clf = model[1].fit(X_train, y_train)
        #print("training Accuracy:", clf.score(X_train, y_train))
        #y_pred = clf.predict(X_test)
        #cls_rep = classification_report(y_test, y_pred)
        #results.append(cls_rep)
        #tn, fp, fn, tp = confusion_matrix(y_test, y_pred).ravel()
        #cm.append([tn, fp, fn, tp ])
        #print([tn, fp, fn, tp ])
        #acc=(tp+tn)/(tp+tn+fp+fn)
        #msg = "%s: %f" % (model[0], acc)
        #print(msg)
    #return names, results, cm

@jit
def train_new(models,  X_train, y_train, X_test, y_test):
    results = []
    cm = []
    names = []
    scoring = 'accuracy'
    #https://scikit-learn.org/stable/modules/cross_validation.html
    #X_train, X_test, y_train, y_test = train_test_split(X, Y, test_size=0.99,  random_state = 0)
    for model in models:
        kfold = model_selection.KFold(n_splits=10, shuffle=True, random_state=seed)
        cv_results = model_selection.cross_val_score(model[1], X_train, y_train, cv=kfold, scoring=scoring)
        results.append(cv_results)
        # names.append(model[0])
        clf = model[1].fit(X_train, y_train)
        y_pred = clf.predict(X_test)
        #cls_rep = classification_report(y_test, y_pred)
        #results.append(cls_rep)
        tn, fp, fn, tp = confusion_matrix(y_test, y_pred).ravel()
        cm.append([tn, fp, fn, tp ])
        print([tn, fp, fn, tp ])
        acc=(tp+tn)/(tp+tn+fp+fn)
        msg = "%s: %f" % (model[0], acc)
        print(msg)
    return names, results, cm

# calculate the kl divergence
def kl_divergence(p, q):
    # pass malware_tf, benign_tf as p and q
    return sum(p[i] * np.log2(p[i]/(q[i] +1)) for i in range(len(p)))
    
if __name__=="__main__":
    K= '1.0'
    # load dataset
    df_train = pd.read_csv('C:/Users/User/OneDrive - Universiti Teknologi Malaysia (UTM)/Desktop/FAIT_DOC/objectives/objective2/proposedKLD-based_TF-ICF/knn_cart_RF_xgboost/10_flod_cross_validation/train_dataset_'+str(K)+'v3m.csv')
    df_test = pd.read_csv('C:/Users/User/OneDrive - Universiti Teknologi Malaysia (UTM)/Desktop/FAIT_DOC/objectives/objective2/proposedKLD-based_TF-ICF/knn_cart_RF_xgboost/10_flod_cross_validation/test_dataset_'+str(K)+'v3m.csv')
    #df_train = pd.concat([df_train, df_test])
    # remove unamed columns in datasetn
    
    
    del df_train['Unnamed: 0.1']
    del df_train['Unnamed: 0']
    del df_test['Unnamed: 0.1']
    del df_test['Unnamed: 0']
    #reset the indexx from zero
    df_train = df_train.reset_index(drop=True)
    #define the TF object. the API into n-gram with TF for each n-gram as matrxix
    vectorizer = CountVectorizer(ngram_range=(1,2),  max_features=485)
    #vectorizer.fit(df_train.api)
    #vectorizer = TfidfVectorizer(ngram_range=(1,2), use_idf=False, max_features=485)
    #caculate the TF output
    X_train_counts = vectorizer.fit_transform(df_train.api)
    # representing in CSR form

    #df_api_count = pd.DataFrame(api_count.toarray(), columns = vectorizer.get_feature_names())
    #vectorizer = TfidfTransformer(use_idf=False).fit(X_train_counts)
    #X_train_tf = vectorizer.transform(X_train_counts)
    #??????????
    #convert the matrix or array into dataframe
    df_api_count = pd.DataFrame(X_train_counts.toarray(), columns = vectorizer.get_feature_names())
    #df_label = df_train['label'].reset_index(drop=True)
    
    #take the size (total number) of each class from the datframe
    malware_samples = df_train.api[df_train.label==1].shape[0];
    #assign the API of benign into benign_samples matrix????????
    benign_samples = df_train.api[df_train.label==0].shape[0];
    #df_api_count = pd.DataFrame(api_count.toarray(), columns = vectorizer.get_feature_names())
    
    #take the number of documents contain this api for both classes
    number_of_samples_api = df_api_count[df_api_count>0].count()
    
    #total number of benign document or malware contain this api
    number_of_samples_api_b = df_api_count[df_train.label==0][df_api_count>0].count()    
    number_of_samples_api_m = df_api_count[df_train.label==1][df_api_count>0].count()
    #term_frequency = df_api_count.div(number_of_samples_api.tolist(),1)

    #number of benign sample contain this api / total number of all benign sample (probability distribution of api in each class)
    malware_tf = number_of_samples_api_m/(df_api_count[df_train.label==1].sum(axis=0) +1) #/(malware_samples+benign_samples)
    benign_tf = number_of_samples_api_b/(df_api_count[df_train.label==0].sum(axis=0)+1) #/(malware_samples+benign_samples)
    
    
    X=df_train['api']
    x=df_train['label']
    x = x.astype('int')
    
    seed = 7
    # prepare models
    models = []
    models.append(('KNN', KNeighborsClassifier()))
    models.append(('CART', DecisionTreeClassifier()))
    models.append(('NB', GaussianNB()))
    models.append(('SVM', SVC()))
    models.append(('ANN', MLPClassifier(solver='lbfgs', alpha=1e-5, hidden_layer_sizes=(15,), random_state=1)))
    models.append(('RF', RandomForestClassifier(n_estimators = 100, random_state = 42)))
    models.append(('LR', LogisticRegression()))
    models.append(('XGboost', XGBClassifier()))
    
    
    #return 0\
    #system.os.exit()
    #term_frequency = pd.concat([term_frequency_m, term_frequency_b])
    
    #compute 
    
    # make sure the formula ???????
    #term_frequency = df_api_count.div(number_of_samples_api.tolist(),1)
    
    #df_api_count = pd.DataFrame(X_train_tf.toarray(), columns = vectorizer.get_feature_names())

    #term_frequency = term_frequency.mul(number_of_samples_api/(number_of_samples_api))
    #assign the total number of api in malware class ????
    #df_api_m = df_api_count[df_train.label==1]
    #compute inverse malware frequency ?????
    #imf=np.log2(malware_samples/(df_api_m.sum(axis=0)+1))
    #imf.replace([np.inf, -np.inf], 0, inplace=True)
    
    #df_api_b = df_api_count[df_train.label==0]
    #ibf=np.log2(benign_samples/(df_api_b.sum(axis=0)+1))
    #ibf.replace([np.inf, -np.inf], 0, inplace=True)
    
    # why ???????????
    #icf= 1- (abs(abs(ibf)-abs(imf))/abs(abs(ibf)+abs(imf)))
    #icf= 1-pd.concat([ibf,imf],1).min(axis=1)/ pd.concat([ibf,imf],1).max(axis=1)
    #icf=1- abs(ibf-imf)/pd.concat([ibf,imf],1).min(axis=1)
    #icf= abs(abs(ibf)-abs(imf))
    #icf =np.log2(abs(benign_samples/(df_api_b.sum(axis=0)+1) - malware_samples/(df_api_m.sum(axis=0)+1)))

    #Plusabilities
    #tf_idf_vec = df_api_count.mul(icf,axis=1)* np.log(-1*kl_divergence(malware_tf, benign_tf))
    tf_idf_vec = df_api_count* np.log(-1*kl_divergence(malware_tf, benign_tf))
    X_train =  tf_idf_vec.to_numpy()
    
    y_train =df_train.label.astype('int')
    X_test_counts = vectorizer.transform(df_test.api)
    df_tf_transformer_test = pd.DataFrame(X_test_counts.toarray(), columns = vectorizer.get_feature_names())
    df_test_f = df_tf_transformer_test * np.log(-1*kl_divergence(malware_tf, benign_tf))
    X_test=df_test_f.to_numpy()
    y_test=df_test.label.astype('int')


    names, results, cm  = train_new(models,  X_train, y_train, X_test, y_test)

    #df_train_f= tf_idf_vec.sample(frac=1)
    #df_test = tf_idf_vec.drop(df_train.index)

    
   
    
    #the same vectrizer that was trained but we pass test dataframe for it
   
    #tf_transformer_text = tf_transformer.transform(X_test_counts)
    
    #number_of_samples_api_test = df_tf_transformer_test[df_tf_transformer_test>0].count()
    #term_frequency_test= df_tf_transformer_test.div(number_of_samples_api_test.tolist(),1)
    #term_frequency_test = pd.DataFrame(tf_transformer.transform(X_train_counts), columns = vectorizer.get_feature_names())
    #df_test_f = df_tf_transformer_test.mul(icf,axis=1)* np.log(-1*kl_divergence(malware_tf, benign_tf))
    # the test is ddone using the divergency method learned in traning through the same variables malware_tf, benign_tf
    
#Compaining the tf-idf 

    # prepare configuration for cross validation test harness
    

    # tfidf_vec_b = TfidfVectorizer(sublinear_tf=True, norm='l2', encoding='latin-1', ngram_range=(1, 2), stop_words='english')
    # X_tfidf_b = tfidf_vec_b.fit_transform(df_train.api[df_train.label==0])
    

    
    
    #combine the dictionaries 


    #names, results, cm = train_re(models, X, y)
    #transfer the traning data and traning labels into numpy or array and list of int before training phase
    
    
    
    #print(cm)

